<CsoundSynthesizer>
<CsOptions>
-odac
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 16
nchnls = 2
0dbfs = 1


opcode Waveshape,a,kkkiiii
    setksmps 1
    kInput[] init 2; input array
    kOutput[] init 2; output array
    kamp,kf,kndx,isin,itf,igf,iUseOversampling  xin
    kndx  = 1
    kPrevIn init 0
    kPrevOut init 0

    kSig oscili 0.5*kndx,kf,-1

    ;write sample to array and zero pad. effectively making the audio signal twice as long..
    kInput[0] = kSig
    kInput[1] = 0
    kPrevIn = kInput[1]
    ;first pass through filters
    kInput[0] = kPrevIn*0.29443409+kInput[0]*0.29443409
    kInput[1] = kInput[0]*0.29443409+kInput[1]*0.29443409

    ;pass samples through transfer function...
    kOutput[0] tablei kInput[0],itf,1,0.5
    kOutput[1] tablei kInput[1],itf,1,0.5
    
    ;pass signal through upsampled lowpass filter at SR/2..
    kOutput[0] = kPrevOut*0.29443409+kOutput[0]*0.29443409
    kOutput[1] = kOutput[0]*0.29443409+kOutput[1]*0.29443409
    kPrevOut = kOutput[1]
    
    ;grab first sample from output array
    aVal upsamp kOutput[0]
    
    ;compare original waveshaping with oversampled version
    if iUseOversampling == 0 then
        aVal tablei upsamp(kSig),itf,1,0.5
    endif

    kscl tablei kndx,igf,1
    xout aVal*kamp*kscl
endop


;instrument
instr 1
    aOut Waveshape 1, cpsmidinn(p4), 1, 1, 2, 3, p5
    outs aOut, aOut
endin

</CsInstruments>
<CsScore>
f1 0 4096 10 1 .1 .1
f2 0 16385 "tanh" -157 157
f3 0  8193 4  2 1
;play a few notes of original waveshaper
i1 0 1 80 0
i1 + 1 81 0
i1 + 1 82 0
i1 + 1 83 0
;now play the 'oversampled' version
i1 + 1 80 1
i1 + 1 81 1
i1 + 1 82 1
i1 + 1 83 1
</CsScore>
</CsoundSynthesizer>